CRs with integer UUIDs cause DB error on VM association: operator does not exist: character
varying = integer
11/27/2015 05:11 AM - Dominic Cleal
Description

Compute resources that return integers from the #identity method of Fog server objects throw an error during VM/host association as
Rails tries to compare an integer to a string column.

PGError: ERROR: operator does not exist: character varying = integer LINE 1: ..."hosts"."compute_r
esource_id" = 1 AND "hosts"."uuid" IN (21) ~ HINT: No operator matches the given name and argument
type(s). You might need to add explicit type casts. : SELECT COUNT (*) FROM "hosts" WHERE "hosts".
"organization_id" IN (1) AND "hosts"."location_id" IN (2) AND "hosts"."type" IN ('Host::Managed')

AND "hosts"."compute_resource_id" = 1 AND "hosts"."uuid" IN (21)

This is called from the Host::Managed.for_vm scope.

Reported at https://github.com/theforeman/foreman-one/issues/8 and | suspect it may also affect foreman-digitalocean whose Fog
server does the same.

Associated revisions

Revision 3ef29ca2 - 11/30/2015 05:00 AM - Dominic Cleal

fixes #12623 - convert VM IDs to strings for DB lookup

Some CR types return the VM identities as integers, but the "uuid
column is a string type. Convert all VM IDs to strings before
comparing to prevent SQL errors on PostgreSQL.

Replaced skip_callback in test factories to prevent it leaking into
other tests and permanently skipping the callback.

Revision ecc88e47 - 01/19/2016 08:10 AM - Dominic Cleal
fixes #12623 - convert VM IDs to strings for DB lookup

Some CR types return the VM identities as integers, but the “uuid
column is a string type. Convert all VM IDs to strings before

comparing to prevent SQL errors on PostgreSQL.

Replaced skip_callback in test factories to prevent it leaking into
other tests and permanently skipping the callback.

(cherry picked from commit 3ef29ca2220ee77f77ec50326e330e0c671341e5)

History

#1 - 11/27/2015 06:07 AM - The Foreman Bot
- Status changed from Assigned to Ready For Testing
- Pull request https://github.com/theforeman/foreman/pull/2940 added
https://github.com/theforeman/foreman-one/issues/8

#2 - 11/30/2015 05:01 AM - Dominic Cleal
- Status changed from Ready For Testing to Closed
- % Done changed from 0 to 100

Applied in changeset 3ef29ca2220ee77f77ec50326e330e0c671341e5.

#3 - 11/30/2015 05:02 AM - Dominic Cleal

- translation missing: en.field_release set to 104
